# layer_shape.cpp File Reference

Implementation of the "Shape" layer. More...

`#include "layer_shape.h"`
`#include "string.h"`
`#include "time.h"`
`#include "context.h"`
`#include "paramdesc.h"`
`#include "renddesc.h"`
`#include "surface.h"`
`#include "value.h"`
`#include "valuenode.h"`
`#include "float.h"`
`#include "blur.h"`
`#include "curve_helper.h"`
`#include <vector>`
`#include <deque>`

## Defines

#define | EPSILON 1e-12
#define | GAUSSIAN_ADJUSTMENT (0.05)

## Typedefs

typedef rect< int > | ContextRect

## Functions

| SYNFIG_LAYER_INIT (Layer_Shape)
| SYNFIG_LAYER_SET_NAME (Layer_Shape,"shape")
| SYNFIG_LAYER_SET_LOCAL_NAME (Layer_Shape, N_("Shape"))
| SYNFIG_LAYER_SET_CATEGORY (Layer_Shape, N_("Internal"))
| SYNFIG_LAYER_SET_VERSION (Layer_Shape,"0.1")
| SYNFIG_LAYER_SET_CVS_ID (Layer_Shape,"$Id$")
template<class T>
bool | IsZero (const T &n)
static void | Subd_Conic_Stack (Point *arc)
static void | Subd_Cubic_Stack (Point *arc)
static bool | clip_conic (const Point *const p, const ContextRect &r)
static bool | clip_cubic (const Point *const p, const ContextRect &r)
static Real | max_edges_cubic (const Point *const p)
static Real | max_edges_conic (const Point *const p)

## Variables

const int | MAX_SUBDIVISION_SIZE = 64
const int | MIN_SUBDIVISION_DRAW_LEVELS = 4

## Detailed Description

Implementation of the "Shape" layer.

$Id$

## Define Documentation

#define EPSILON 1e-12

#define GAUSSIAN_ADJUSTMENT (0.05)

## Typedef Documentation

typedef rect<int> ContextRect

## Function Documentation

SYNFIG_LAYER_INIT | ( | Layer_Shape |  | ) |

SYNFIG_LAYER_SET_NAME | ( | Layer_Shape | ,
|  | "shape" |  |
| ) |  |  |

SYNFIG_LAYER_SET_LOCAL_NAME | ( | Layer_Shape | ,
|  | N_("Shape") |  |
| ) |  |  |

SYNFIG_LAYER_SET_CATEGORY | ( | Layer_Shape | ,
|  | N_("Internal") |  |
| ) |  |  |

SYNFIG_LAYER_SET_VERSION | ( | Layer_Shape | ,
|  | "0.1" |  |
| ) |  |  |

SYNFIG_LAYER_SET_CVS_ID | ( | Layer_Shape | ,
|  | "$Id$" |  |
| ) |  |  |

template<class T>

bool IsZero | ( | const T & | n | ) | `[inline]`

References EPSILON.

static void Subd_Conic_Stack | ( | Point * | arc | ) | `[static]`

static void Subd_Cubic_Stack | ( | Point * | arc | ) | `[static]`

static bool clip_conic | ( | const Point *const | p,
|  | const ContextRect & | r |
| ) |  |  | `[inline, static]`

static bool clip_cubic | ( | const Point *const | p,
|  | const ContextRect & | r |
| ) |  |  | `[inline, static]`

static Real max_edges_cubic | ( | const Point *const | p | ) | `[inline, static]`

static Real max_edges_conic | ( | const Point *const | p | ) | `[inline, static]`

## Variable Documentation

const int MAX_SUBDIVISION_SIZE = 64

const int MIN_SUBDIVISION_DRAW_LEVELS = 4